package classinfo.attribute;

import java.io.DataOutputStream;
import java.io.IOException;
import classinfo.*;

public
class AttributeInfo {
  public static final String ATTRIBUTE_NAME = null;
  static final int STRING_BUFFER_SIZE = 100;

  ConstantPoolReference name;
  int len;
  byte[] contents;

  public AttributeInfo(ConstantPoolReference name, int len) {
    this.name = name;
    this.len = len;
  }

  public AttributeInfo(ConstantPoolReference name, int len, BufManager bufm)
	throws IOException {
    this(name, len);

    contents = new byte[len];
    bufm.advance(contents, 0, len);
  }


  public void write(DataOutputStream out)
	throws java.io.IOException {
    out.write(this.contents, 0, this.len);
  }


  public ConstantPoolReference nameIndex() { return name; }
  public int length() { return len; }


  public String toString() { return this.toString(""); }

  public String toString(String indent) {
    StringBuffer buf = new StringBuffer(AttributeInfo.STRING_BUFFER_SIZE);

    buf.append(indent + "Attribute:\n");
    buf.append(indent + "\tName: " + name.toString() + "\n");
    buf.append(indent + "\tLength: " + len + "\n");

    return buf.toString();
  }
}
