package classinfo.attribute;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import classinfo.*;

public
class ExceptionTable {
  int startPC;		// 2 bytes
  int endPC;		// 2 bytes
  int handlerPC;	// 2 bytes
  ConstantPoolReference catchType;	// 2 bytes

  public ExceptionTable(BufManager bufm, Vector CP)
	throws IOException {
    bufm.clearBuffer();
    bufm.advance(8);
    startPC = bufm.parseInt(0, 2);
    endPC = bufm.parseInt(2, 2);
    handlerPC = bufm.parseInt(4, 2);
    catchType = new ConstantPoolReference(bufm.parseInt(6, 2), CP);
  }


  public void write(DataOutputStream out)
	throws java.io.IOException {
    out.writeShort((short)startPC);
    out.writeShort((short)endPC);
    out.writeShort((short)handlerPC);
    out.writeShort((short)catchType.index());
  }


  public String toString() { return toString(""); }

  public String toString(String indent) {
    StringBuffer buf = new StringBuffer(AttributeInfo.STRING_BUFFER_SIZE);

    buf.append(indent + "Exception table:\n");
    buf.append(indent + "\tstart PC: " + startPC + "\n");
    buf.append(indent + "\tend PC: " + endPC + "\n");
    buf.append(indent + "\thandler PC: " + handlerPC + "\n");

    buf.append(indent + "\tcatch type: ");
    if (catchType.index() == 0) {	// catch all types of exceptions
      buf.append("All types of Exceptions\n");
    }
    else {
      buf.append(catchType.toString() + "\n");
    }

    return buf.toString();
  }
}
